function [ h_hat ] = sample_PSF_Gibbs( h0,x,y,sig2n,sig2h )
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% written by N.ZHAO (ENSEEIHT-IRIT, PhD student)
% date: 2014/07/08
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INPUT 
%%     
[m,n]=size(y);
[m0,n0]=size(h0);
h0=padarray(h0,[m-m0+1,n-n0+1]/2,'pre');
h0=padarray(h0,[m-m0-1,n-n0-1]/2,'post');
%% 
% % PO algorithm
% mu1=y;
% mu2=h0;
% eta1  = mu1+randn(size(mu1))*sqrt(sig2n);
% eta2  = mu2+randn(size(mu2))*sqrt(sig2h);
% FQ    = abs(fft2( fftshift(x) )).^2/sig2n+ones(size(x))/sig2h;
% Fb    = fft2(ifft2(conj(fft2(fftshift(x))).*fft2(eta1))/sig2n + eta2/sig2h);
% Fh    = Fb./FQ;
% h_hat = ifft2(Fh);

% % direct sampling
R_Fh = 1./(ones(size(x))/sig2h + abs(fft2( fftshift(x))).^2/sig2n);
m_Fh = R_Fh.*(fft2(h0)/sig2h + conj(fft2(fftshift(x))).*fft2(y)/sig2n);
Fh   = m_Fh + randn(size(x)).*sqrt(R_Fh) ;
h_hat=real(ifft2(Fh));

% figure(30),imagesc(h_hat),colormap gray
%%

h_hat=h_hat((m-m0+1)/2+1:(m+m0+1)/2,(n-n0+1)/2+1:(n+n0+1)/2);
h_hat=h_hat/sum(sum(h_hat));
end
