
function sig2n = sample_sig2n_Gibbs(x,psf,y,wt,varargin)
%|this program is to sample the variance of noise according to its
%|conditional posterior distribution
%|p(sig2n|...) \sim IG(alpha+N/2,beta2+.5*||y-HPx||^2)
if nargin < 4
    error('Not enough inputs');
end

if nargin<5
    alpha=0; 
    beta=0;
elseif nargin<6
    beta=0; 
    alpha=varargin{1};
elseif nargin<7
    alpha=varargin{1};
    beta=varargin{2};
else
    return;
end
    
global wave_kernel N_lev s;

if wt==0
    temp=y-Hx_cal( psf,x );
    sig2n=1/gamrnd(alpha+numel(x)/2,1/(beta+.5*norm(temp(:))^2));    
elseif wt==1
    temp=y-Hx_cal( psf,wav_x(x,wave_kernel,N_lev,1,s) );
    sig2n=1/gamrnd(alpha+numel(x)/2,1/(beta+.5*norm(temp(:))^2));
end

end