function [scale_new,accept_scale,wind,walk_scale]= scale_sample_MH(scale_old,xi,theta,walk_scale,wind,ii,n0)
%|sample sig2x using Metropolis Hastings method with random walk
%|prior of sig2x: Jefferey distribution
%|2014/02/24

N=numel(theta);
scale_cand = scale_old + walk_scale*randn;     

f_func=@(scale) N*log(2*scale^(1/xi)*gamma(1+1/xi))+norm(theta(:),xi)^xi/scale+log(scale);
f_cand=f_func(scale_cand);
f_old=f_func(scale_old);

if scale_cand>0.01
    accept= min(exp(f_old-f_cand),1);
else
    accept=0;
end
   
urn = rand(1);
if urn<=accept
    scale_new=scale_cand;
    label=1;
else
    scale_new=scale_old;
    label=0;
end
%% adjust the random walk size 
nwind=30;
wind=[wind(1,2:nwind),label];
accept_scale=mean(wind);
if ii-1<=n0
    if  accept_scale<0.3
        walk_scale=walk_scale*(1-0.2);
    elseif accept_scale>0.9
        walk_scale= walk_scale*(1+0.2);
    end
elseif ii-1>n0
    if  accept_scale<0.3
        walk_scale=walk_scale*(1-0.1*exp(-0.01*(ii-n0)));
        elseif accept_scale>0.9
        walk_scale= walk_scale*(1+0.1*exp(-0.01*(ii-n0)));
    end
end
    

